<?php
include_once('class.errHandler.php');

class Database_mysql extends errHandler
{
	var $name = '';
	var $isRunning = true; // always run

	function Database_mysql($db_name)
	{
		if (empty($db_name)) {
			$this->setError_('Database name is empty.');
			return;
		}

		$this->name = $db_name;

		return;
	}

	function create()
	{
		// VZA : redirect to VE
		$res = mysql_query_in_ve('create database `' . $this->name . '`');
		if (!$res) {
			$error = (mysql_errno() == 1064) ? lmsg('__can_not_use_reserved_words') : $this->get_db_error();
			$this->setError_($error);
			return false;
		}

		return true;
	}

	function remove()
	{
		// VZA : redirect to VE
		$res = mysql_query_in_ve('drop database if exists `' . $this->name . '`');
		if (!$res) {
			$this->setError_('Unable to query: ' . $this->get_db_error());
			return false;
		}

		return true;
	}

	function userAdd($login, $pass, $type = 'plain')
	{
		if ($this->userExistance($login)) {
			$this->setError_(lmsg('__user_already_exist', $login));
			return false;
		}

		// VZA : redirect to VE, and change Host permissions
		$access_host = is_vzplesk_mode() ?  '%' : 'localhost'; // fixme: seems that we have to allow access only from service VE

		if ($type != 'plain' && $type != 'crypt')
			psaerror('Unable to set password: not supported type.');

		$pass = ('plain' == $type)? 'PASSWORD("' . mysql_escape_string($pass) . '")' : '"' . mysql_escape_string($pass) . '"';

		// Check state of table 'mysql.user' by Plesk's added columns, mysql server version is not correct way.
		$res = db_query('desc mysql.user Show_db_priv;');
		$is_mysql4 = mysql_num_rows($res) != 0;

		if ($is_mysql4) 
			$query = 'insert into mysql.user (Host, User, Password, Select_priv, Insert_priv, Update_priv, Delete_priv, Create_priv, Drop_priv, Reload_priv, Shutdown_priv, Process_priv, File_priv, Grant_priv, References_priv, Index_priv, Alter_priv, Show_db_priv, Super_priv, Create_tmp_table_priv, Lock_tables_priv, Execute_priv, Repl_slave_priv, Repl_client_priv) values("' . mysql_escape_string($access_host) . '", "' . mysql_escape_string($login) . '", ' . $pass . ', "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N")';
		else
			$query = 'insert into mysql.user (Host, User, Password, Select_priv, Insert_priv, Update_priv, Delete_priv, Create_priv, Drop_priv, Reload_priv, Shutdown_priv, Process_priv, File_priv, Grant_priv, References_priv, Index_priv, Alter_priv) values("' . mysql_escape_string($access_host) . '", "' . mysql_escape_string($login) . '", ' . $pass . ', "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N")';

		$res = mysql_query_in_ve($query);
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		/// Fix mysql bug with underline
		$db_name_slashed = str_replace('_', '\_', str_replace('\_', '_', $this->name));

		if ($is_mysql4)
			$query = 'insert into mysql.db (Host, Db, User, Select_priv, Insert_priv, Update_priv, Delete_priv, Create_priv, Drop_priv, Grant_priv, References_priv, Index_priv, Alter_priv, Create_tmp_table_priv, Lock_tables_priv) values("' . mysql_escape_string($access_host) . '", "' . mysql_escape_string($db_name_slashed) . '", "' . mysql_escape_string($login) . '", "Y", "Y", "Y", "Y", "Y", "Y", "N", "Y", "Y", "Y", "Y", "Y");';
		else
			$query = 'insert into mysql.db (Host, Db, User, Select_priv, Insert_priv, Update_priv, Delete_priv, Create_priv, Drop_priv, Grant_priv, References_priv, Index_priv, Alter_priv) values("' . mysql_escape_string($access_host) . '", "' . mysql_escape_string($db_name_slashed) . '", "' . mysql_escape_string($login) . '", "Y", "Y", "Y", "Y", "Y", "Y", "N", "Y", "Y", "Y");';

		// VZA : redirect to VE, and change Host permissions
		$res = mysql_query_in_ve($query);
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		// VZA : redirect to VE
		mysql_query_in_ve('flush privileges');

		return true;
	}

	/**
	 *	Parameters - 3 arrays:
	 *	$logins = array($old_login => $new_login);
	 *	$pass
	 */
	function userMod(&$logins, $pass, $type = 'plain')
	{
		if (!(list($old_login, $new_login) = each($logins)))
			psaerror('Unable to get user variables.');

		/// login changed - check if new user already exists in mysql db
		if ($new_login != $old_login) {
			if ($this->userExistance($new_login)) {
				$this->setError_(lmsg('__user_already_exist', $new_login));
				return false;
			}
		}

		if ($type != 'plain' && $type != 'crypt')
			psaerror('Unable to set password: not supported type.');

		$pass = ('plain' == $type)? 'PASSWORD("' . mysql_escape_string($pass) . '")' : '"' . mysql_escape_string($pass) . '"';

		$query = 'update mysql.user set mysql.user.User=("' . mysql_escape_string($new_login) . '"), mysql.user.Password = ' . $pass . ' where mysql.user.User="' . mysql_escape_string($old_login) . '"';
		// VZA : redirect to VE
		$res = mysql_query_in_ve($query);
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		$query = 'update mysql.db set mysql.db.User=("' . mysql_escape_string($new_login) . '") where mysql.db.User="' . mysql_escape_string($old_login) . '"';
		// VZA : redirect to VE
		$res = mysql_query_in_ve($query);
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		// VZA : redirect to VE
		mysql_query_in_ve('flush privileges');

		return true;
	}

	function changePassword($login, $old_passwd, $passwd, $type = 'plain')
	{
		if ($type != 'plain' && $type != 'crypt')
			psaerror('Unable to set password: not supported type.');

		$passwd = ('plain' == $type)? 'PASSWORD("' . mysql_escape_string($passwd) . '")' : '"' . mysql_escape_string($passwd) . '"';

		// just change the password
		$query = 'update mysql.user set Password=' . $passwd . ' where User="' . mysql_escape_string($login) . '" and Password=PASSWORD("' . mysql_escape_string($old_passwd) . '")';
		// VZA : seems that it was a bug in plesk mainstream
		$res = mysql_query_in_ve($query);
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		return true;
	}

	function userDel($login)
	{
		// VZA : redirect to VE
		$res = mysql_query_in_ve('delete from mysql.user where User="' . mysql_escape_string($login) . '"');
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		// VZA : redirect to VE
		$res = mysql_query_in_ve('delete from mysql.db where User="' . mysql_escape_string($login) . '"');
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		// VZA : redirect to VE
		mysql_query_in_ve('flush privileges');

		return true;
	}

	function userAccessDisable($login)
	{
		$query = 'update mysql.user set mysql.user.Password="!!" where mysql.user.User="' . mysql_escape_string($login) . '"';
		// VZA : redirect to VE
		$res = mysql_query_in_ve($query);
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		// VZA : redirect to VE
		mysql_query_in_ve('flush privileges');

		return true;
	}

	function userExistance($login)
	{
		// VZA : redirect to VE
		/// check if such user already exists in database
		$res = mysql_query_in_ve('select m.User from mysql.user m where m.User="' . mysql_escape_string($login) . '"');
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		$ret_val = (mysql_num_rows($res) != 0);
		mysql_free_result($res);

		return $ret_val;
	}

	function getSize()
	{
		$params = array(MYSQL_ROOT . '/' . $this->name);
		$ret = util_exec('get_dir_size', $params, 'lst');
		if (!$ret) {
			$this->setError_(lmsg('__unable_to_define_db_size'));
			return 0;
		}

		return $ret[0];
	}

	function get_db_error()
	{
		return mysql_error();
	}
}
?>
