<?php

/*
 * To create new database support define a correspondent constant
 * in constants.php3 file, add new database support into
 * get_db_list() function in a cmd_server.php3 file
 * create database_dbType.inc file from this template.
 */

include_once('class.errHandler.php');

class Database_XXX extends errHandler
{
	var $db_type	= DB_XXX;
	var $db_data;					// data from get_db_list() function
	var $name		= '';
	var $host		= 'localhost';
	var $connection	= false;
	var $isRunning;	

	function Database_XXX($db_name)
	{
		if (empty($db_name)) {
			$this->setError_('Database name is empty.');
			return;
		}

		$this->name = $db_name;

		include_once('cmd_server.php3');
		$db_list =& get_db_list();
		$this->db_data = $db_list[$this->db_type];

		/// Check for DATABASE is installed
		include_once('class.Components.php');

		$components = new Components();
		if ($components->error()) {
			$this->setError_('Components() constructor failed: ' . $components->getErrorMsg());
			return false;
		}

		$isInstalled = $components->isPackageInstalled($this->db_type);
		if ($components->error()) {
			$this->setError_('isPackageInstalled() failed: ' . $components->getErrorMsg());
			return false;
		}
		if (!$isInstalled) {
			$this->setError_(lmsg('__database_not_installed', $this->db_data['name']));
			return false;
		}

		/// Check for DATABASE is runnig
/*
		include_once('class.ServiceControl.php');
		$service = new ServiceControl();
		if ($service->error())
			psaerror('ServiceControl() constructor failed: ' . $service->getErrorMsg());

		include_once('cmd_server.php3');
		$this->isRunning = $service->isServiceRunning(get_service_daemon($this->db_type));
		if ($service->error()) {
			$this->setError_('isServiceRunning() failed: ' . $service->getErrorMsg());
			return false;
		}
		if (!$this->isRunning) {
			$this->setError_(lmsg('__database_not_run', $this->db_data['name']));
			return false;
		}
*/
		if (!$this->connect()) {
			$this->setError_('Unable to connect to ' . $this->db_data['name'] . ' database: ' . $this->getErrorMsg());
			return false;
		}

		return;
	}

	function connect()
	{
		if (false != $this->connection)
			return $this->connection;

		$login	= get_param($this->db_type . DB_ADMIN_LOGIN_SUFFIX);
		$passwd	= get_param($this->db_type . DB_ADMIN_PASSWD_SUFFIX);

		if (empty($login)) {
			$this->setError_(lmsg('__database_not_activated', $this->db_data['name']));
			return false;
		}

		///	Local connect
		$this->connection = XXX_connect($this->name, $login, $passwd);
		if (!$this->connection) {
			$this->setError_($this->get_db_error());
			return false;
		}

		return true;
	}

	function create()
	{
		if ($this->dbExistance($this->name)) {
			$this->setError_(lmsg('__db_already_exist', $this->name));
			return false;
		}

		$res = XXX_query('CREATE DATABASE "' . $this->name . '"');
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		return true;
	}

	function remove()
	{
		$res = XXX_query('DROP DATABASE "' . $this->name . '"');
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		return true;
	}

	function userAdd($login, $pass)
	{
		if ($this->userExistance($login)) {
			$this->setError_(lmsg('__user_already_exist', $login));
			return false;
		}

		$res = XXX_query("CREATE USER $login WITH PASSWORD '$pass' NOCREATEDB NOCREATEUSER");
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		return true;
	}

	/**
	 *	Parameters - 3 arrays:
	 *	$logins = array($old_login => $new_login);
	 *	$pass
	 */
	function userMod(&$logins, $pass)
	{
		if (!(list($old_login, $new_login) = each($logins)))
			psaerror('Unable to get user variables.');

		// change the password
		$res = XXX_query("ALTER USER $old_login WITH PASSWORD '$pass'");
		if (!$res) {
			$this->setError_('Unable to query: ' . $this->get_db_error());
			return false;
		}

		/// login changed - check if new user already exists in XXX db
		if ($new_login == $old_login)
			return true;

		if ($this->userExistance($new_login)) {
			$this->setError_(lmsg('__user_already_exist', $new_login));
			return false;
		}

		$res = XXX_query("update XXX_shadow set usename='$new_login', passwd='$pass' where usename='$old_login'");
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		return true;
	}

	function userDel($login)
	{
		$res = XXX_query("DROP USER $login");
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		return true;
	}

	function userAccessDisable($login)
	{
		$res = pg_query("ALTER user $login VALID UNTIL '01 Jan 1970'");
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		return true;
	}

	function dbExistance($db_name)
	{
		$res = XXX_query("SELECT * FROM XXX_database WHERE datname='$db_name'");
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		$ret_val = (XXX_numrows($res) != 0);
		XXX_freeresult($res);

		return $ret_val;
	}

	function userExistance($login)
	{
		$res = XXX_query("SELECT * FROM XXX_shadow WHERE usename='$login'");
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		$ret_val = (XXX_numrows($res) != 0);
		XXX_freeresult($res);

		return $ret_val;
	}

	function getSize()
	{
		$res = XXX_query('select oid from XXX_database where datname=\'' . $this->name . '\'');
		if (!$res)
			psaerror('Unable to query: ' . $this->get_db_error());

		if (!(list($db_oid) = XXX_fetch_array($res))) {
			$this->setError_('Unable to get Database oid.');
			XXX_freeresult($res);
			return 0;
		}
		XXX_freeresult($res);

		$args = array(POSTGRES_ROOT . '/base/' . $db_oid);
		$ret = util_exec('get_dir_size', $args, 'lst');
		if (!$ret) {
			global $plesk_errormsg;
			$this->setError_('get_dir_size failed: ' . $plesk_errormsg);
			return false;
		}

		return $ret[0];
	}

	function get_db_error()
	{
		return XXX_last_error();
	}
}
?>
